#include <windows.h>
#pragma hdrstop

#include "Cpdio.h"
#include "SiUSBXp.h"

#pragma package(smart_init)

//------------------------------ Constants: ---------------------------------

#define TIMEOUT 200 //timeout, mS

//------------------------------ Variables: ---------------------------------

HANDLE    siHandle; //device handle
SI_STATUS siStatus; //device status

//----------------------------- List devices: -------------------------------

bool __fastcall ListDevices(DWORD &numDevs)
{
  siStatus = SI_GetNumDevices(&numDevs);
  return(siStatus == SI_SUCCESS);
}

//------------------------------ Open port: ---------------------------------

bool __fastcall OpenPort(int Dev, HANDLE &devHandle)
{
  siStatus = SI_Open(Dev, &siHandle);
  devHandle = siHandle;
  return(siStatus == SI_SUCCESS);
}

//------------------------------ Open port: ---------------------------------

bool __fastcall SetupPort(DWORD Baud)
{
  siStatus = SI_SetBaudRate(siHandle, Baud);
    if (siStatus != SI_SUCCESS) return false;    //set baud error
  siStatus = SI_SetLineControl(siHandle, 0x800); //1 sb, no parity, 8 bits
    if (siStatus != SI_SUCCESS) return false;    //set mode error
  siStatus = SI_SetTimeouts(TIMEOUT, TIMEOUT);
    if (siStatus != SI_SUCCESS) return false;    //set timeouts error
  siStatus = SI_FlushBuffers(siHandle, 1, 1);
    if (siStatus != SI_SUCCESS) return false;    //buffers flush error
 return true;
}

//------------------------------ Close port: --------------------------------

bool __fastcall ClosePort(HANDLE &devHandle)
{
  siStatus = SI_Close(siHandle);
  devHandle = NULL;
  return(siStatus == SI_SUCCESS);
}

//---------------------------- Transmit buffer: -----------------------------

bool __fastcall TxBuff(DWORD j, unsigned char *buff)
{ DWORD r;
  siStatus = SI_Write(siHandle, buff, j, &r);
    if (siStatus != SI_SUCCESS) return false;
    if (r != j) return false;
  return true;
}

//------------------------------ Receive byte: ------------------------------

bool __fastcall RxByte(unsigned char &b)
{ DWORD r;
  siStatus = SI_Read(siHandle, &b, 1, &r);
    if (siStatus != SI_SUCCESS) return false;
    if (r != 1) return false;
  return true;
}

//-------------------------- Set receive timeout: ---------------------------

bool __fastcall SetRxTo(DWORD to)
{
  siStatus = SI_SetTimeouts(to, TIMEOUT);
  return(siStatus == SI_SUCCESS);
}

//---------------------------------------------------------------------------

